## instead 2.4.1

=== CMakeLists.txt ===
PROJECT(instead)

CMAKE_MINIMUM_REQUIRED(VERSION 2.6.0)
SET(CMAKE_MODULE_PATH ${PROJECT_SOURCE_DIR}/cmake)

IF("${PROJECT_SOURCE_DIR}" STREQUAL "${PROJECT_BINARY_DIR}")
	MESSAGE(FATAL_ERROR "In-source builds are not allowed. Please read ./INSTALL")
ENDIF("${PROJECT_SOURCE_DIR}" STREQUAL "${PROJECT_BINARY_DIR}")

# global constants
SET(INSTEAD_VERSION "2.4.1")

# options
OPTION(WITH_SDL2 "Use SDL2 instead of SDL 1" OFF)
OPTION(WITH_GTK2 "Use GTK2 file open dialog" ON)
OPTION(WITH_GTK3 "Use GTK3 file open dialog" OFF)
OPTION(WITH_ICONV "Build with iconv support" ON)

# Note: there are three build modes for instead:
# - SYSTEMWIDE
#     use it if you want to install it into your (unix) system
# - STANDALONE
#     used to generate standalone relocatable package which
#     may be run from anywhere. `install' target stages all
#     required files in ${STANDALONEDIR} for you
# - neither (both options disabled)
#     instead may be run from build directory, useful for
#     development
OPTION(SYSTEMWIDE "Build for systemwide install" ON)
OPTION(STANDALONE "Build for standalone package creation" OFF)

IF(WITH_GTK2 AND WITH_GTK3)
	MESSAGE(FATAL_ERROR "WITH_GTK2 and WITH_GTK3 are mutually exclusive")
ENDIF(WITH_GTK2 AND WITH_GTK3)

IF(SYSTEMWIDE AND STANDALONE)
	MESSAGE(WARNING "Both STANDALONE and SYSTEMWIDE specified, disabling SYSTEMWIDE")
	SET(SYSTEMWIDE OFF)
ENDIF(SYSTEMWIDE AND STANDALONE)

SET(BINDIR "bin" CACHE STRING "Where to install binaries")
SET(DATADIR "share/instead" CACHE STRING "Where to install data files")
SET(STEADDIR "${DATADIR}/stead" CACHE STRING "Where to install stead files")
SET(THEMESDIR "${DATADIR}/themes" CACHE STRING "Where to install themes")
SET(GAMESDIR "${DATADIR}/games" CACHE STRING "Where to install games")
SET(ICONDIR "share/pixmaps" CACHE STRING "Where to install icons")
SET(DOCDIR "share/doc/instead" CACHE STRING "Where to install documentation")
SET(LANGDIR "${DATADIR}/lang" CACHE STRING "Where to install language files")
SET(MANDIR "share/man" CACHE STRING "Where to install man pages")
SET(DESKTOPDIR "share/applications" CACHE STRING "Where to install .desktop files")

SET(STANDALONEDIR "${PROJECT_BINARY_DIR}/standalone" CACHE STRING "Where to stage stanalone package")

# subdirectories
ADD_SUBDIRECTORY(desktop)
ADD_SUBDIRECTORY(doc)
ADD_SUBDIRECTORY(games)
ADD_SUBDIRECTORY(icon)
ADD_SUBDIRECTORY(lang)
ADD_SUBDIRECTORY(src/sdl-instead)
ADD_SUBDIRECTORY(stead)
ADD_SUBDIRECTORY(themes)

=== Makefile ===
include Rules.make
include config.make

VERTITLE := instead-$(VERSION)
ARCHIVE := instead_$(VERSION).tar.gz#

SUBDIRS += src/sdl-instead stead games themes icon desktop doc lang

all:
	@for dir in $(SUBDIRS); do \
		$(MAKE) -C $$dir $(@) || exit 1; \
	done;

Rules.make:
	ln -sf Rules.make.standalone Rules.make

config.make:
	echo "# you can define own flags here" > config.make

svnclean:
	{ test -d .svn && svn st; } | grep "^?" | awk '{ print $$2 }' | grep -v "config.make" | while read l; do $(RM) -rf $$l; done

gitclean:
	{ test -d .git && git status -s; } | grep "^??" | awk '{ print $$2 }' | grep -v "config.make" | while read l; do $(RM) -rf $$l; done

rules:
	$(RM) -f Rules.make
	ln -sf Rules.make.standalone Rules.make

docs: rules
	make docs -C doc/

PKGBUILD: PKGBUILD.in tarball
	cat PKGBUILD.in | sed -e s/MD5SUM/`md5sum $(ARCHIVE) | cut -f1 -d' '`/g > PKGBUILD

caanoo.tar.gz:
	wget "http://sourceforge.net/projects/instead/files/instead/build-bin-data/$(@)/download" -O $(@)

mingw32ce.tar.gz:
	wget "http://sourceforge.net/projects/instead/files/instead/build-bin-data/$(@)/download" -O $(@)

windows-sdl2.tar.gz:
	wget "http://sourceforge.net/projects/instead/files/instead/build-bin-data/$(@)/download" -O $(@)

build-bin-data: caanoo.tar.gz mingw32ce.tar.gz windows-sdl2.tar.gz

tarball: clean svnclean gitclean docs rules
	echo "# you can define own flags here" > config.make
	ln -sf ./ $(VERTITLE)
	tar -cz --exclude $(VERTITLE)/$(VERTITLE) --exclude CJK.zip --exclude .git --exclude .svn --exclude $(ARCHIVE) --exclude mingw32ce.tar.gz --exclude windows-sdl2.tar.gz --exclude caanoo.tar.gz -f $(ARCHIVE) $(VERTITLE)/*
	$(RM) -f $(VERTITLE)

clean:
	@for dir in $(SUBDIRS); do \
		$(MAKE) clean -C $$dir $(@) || exit 1; \
	done;
	$(RM) -f $(ARCHIVE)
	$(RM) -f PKGBUILD

install: all
ifeq ($(SYSTEMSETUP), yes)
	@for dir in $(SUBDIRS); do \
		$(MAKE) -C $$dir install || exit 1; \
	done;
else
	echo No install needed
endif

uninstall:
ifeq ($(SYSTEMSETUP), yes)
	@for dir in $(SUBDIRS); do \
		$(MAKE) -C $$dir uninstall || exit 1; \
	done;
	$(RM) -rf $(STEADPATH)
else
	echo No uninstall needed
endif

=== doc/CMakeLists.txt ===
SET(DOC_FILES
	index.html
)

SET(GENERATED_DOC_FILES
	instead-manual-en.html
	instead-manual.html
	instead-manual.pdf
	instead-modules.pdf
	instead.txt
)

FOREACH(FILE ${GENERATED_DOC_FILES})
	IF(EXISTS ${CMAKE_CURRENT_SOURCE_DIR}/${FILE})
		SET(DOC_FILES ${DOC_FILES} ${FILE})
	ELSE(EXISTS ${CMAKE_CURRENT_SOURCE_DIR}/${FILE})
		SET(MISSING_FILES ${MISSING_FILES} ${FILE})
	ENDIF(EXISTS ${CMAKE_CURRENT_SOURCE_DIR}/${FILE})
ENDFOREACH(FILE ${GENERATED_DOC_FILES})

IF(NOT "${MISSING_FILES}" STREQUAL "")
	MESSAGE(WARNING "This distribution lacks some documentation files: ${MISSING_FILES}. These may be generated (network access and additional tools required, see doc/makepdfs), or you may use instead source tarball from sourceforge which has these files included")
ENDIF(NOT "${MISSING_FILES}" STREQUAL "")

IF(SYSTEMWIDE)
	INSTALL(FILES ${DOC_FILES} DESTINATION ${DOCDIR})
	INSTALL(FILES instead.6 DESTINATION ${MANDIR}/man6)
ELSEIF(STANDALONE)
	INSTALL(FILES ${DOC_FILES} DESTINATION ${STANDALONEDIR}/doc)
ENDIF(SYSTEMWIDE)

=== doc/Makefile ===
include ../Rules.make
include ../config.make

all:
clean:

pdf:
	./makepdfs
#	# try xetex here, and hope it works ;)
#	pdflatex reference.tex
#	makeindex reference.idx
#	pdflatex reference.tex
#	$(RM) -f reference.aux reference.log reference.toc reference.out reference.idx reference.ind reference.ilg
#to-do: interpret $PATH
man:
	man ./instead.6 | col -b > instead.txt

wiki:
	wget "http://instead.syscall.ru/wiki/doku.php?id=ru:gamedev:documentation&do=export_xhtml" -O instead-manual.html
	wget "http://instead.syscall.ru/wiki/doku.php?id=en:gamedev:documentation&do=export_xhtml" -O instead-manual-en.html

docs:	wiki man pdf

install:
	$(INSTALLD) $(DESTDIR)$(DOCPATH)
	-$(INSTALL) instead.txt *.html *.pdf $(DESTDIR)$(DOCPATH)

	$(INSTALLD) $(DESTDIR)$(MANPATH)
	$(INSTALL) *.6 $(DESTDIR)$(MANPATH)

uninstall:
	$(RM) -rf $(DESTDIR)$(DOCPATH)
	$(RM) $(DESTDIR)$(MANPATH)/instead.*

=== stead/CMakeLists.txt ===
FILE(GLOB STEAD_FILES "*.lua")

IF(SYSTEMWIDE)
	INSTALL(FILES ${STEAD_FILES} DESTINATION ${STEADDIR})
ELSEIF(STANDALONE)
	INSTALL(FILES ${STEAD_FILES} DESTINATION ${STANDALONEDIR}/stead)
ENDIF(SYSTEMWIDE)

=== stead/Makefile ===
include ../Rules.make
include ../config.make

clean:
all:	stead.lua

install:
	$(INSTALLD) $(DESTDIR)$(STEADPATH)
	$(INSTALL) stead.lua $(DESTDIR)$(STEADPATH)/stead.lua
	$(INSTALL) gui.lua $(DESTDIR)$(STEADPATH)/gui.lua
	$(INSTALL) walk.lua $(DESTDIR)$(STEADPATH)/walk.lua
	$(INSTALL) xact.lua $(DESTDIR)$(STEADPATH)/xact.lua
	$(INSTALL) input.lua $(DESTDIR)$(STEADPATH)/input.lua
	$(INSTALL) click.lua $(DESTDIR)$(STEADPATH)/click.lua
	$(INSTALL) finger.lua $(DESTDIR)$(STEADPATH)/finger.lua
	$(INSTALL) events.lua $(DESTDIR)$(STEADPATH)/events.lua
	$(INSTALL) dbg.lua $(DESTDIR)$(STEADPATH)/dbg.lua
	$(INSTALL) vars.lua $(DESTDIR)$(STEADPATH)/vars.lua
	$(INSTALL) prefs.lua $(DESTDIR)$(STEADPATH)/prefs.lua
	$(INSTALL) snapshots.lua $(DESTDIR)$(STEADPATH)/snapshots.lua
	$(INSTALL) object.lua $(DESTDIR)$(STEADPATH)/object.lua
	$(INSTALL) format.lua $(DESTDIR)$(STEADPATH)/format.lua
	$(INSTALL) dash.lua $(DESTDIR)$(STEADPATH)/dash.lua
	$(INSTALL) para.lua $(DESTDIR)$(STEADPATH)/para.lua
	$(INSTALL) quotes.lua $(DESTDIR)$(STEADPATH)/quotes.lua
	$(INSTALL) timer.lua $(DESTDIR)$(STEADPATH)/timer.lua
	$(INSTALL) kbd.lua $(DESTDIR)$(STEADPATH)/kbd.lua
	$(INSTALL) hotkeys.lua $(DESTDIR)$(STEADPATH)/hotkeys.lua
	$(INSTALL) hideinv.lua $(DESTDIR)$(STEADPATH)/hideinv.lua
	$(INSTALL) theme.lua $(DESTDIR)$(STEADPATH)/theme.lua
	$(INSTALL) sprites.lua $(DESTDIR)$(STEADPATH)/sprites.lua
	$(INSTALL) sound.lua $(DESTDIR)$(STEADPATH)/sound.lua
	$(INSTALL) wroom.lua $(DESTDIR)$(STEADPATH)/wroom.lua
	$(INSTALL) nouse.lua $(DESTDIR)$(STEADPATH)/nouse.lua
	$(INSTALL) dlg.lua $(DESTDIR)$(STEADPATH)/dlg.lua
	$(INSTALL) counters.lua $(DESTDIR)$(STEADPATH)/counters.lua
	$(INSTALL) proxymenu.lua $(DESTDIR)$(STEADPATH)/proxymenu.lua
	$(INSTALL) nolife.lua $(DESTDIR)$(STEADPATH)/nolife.lua

uninstall:
	$(RM) $(DESTDIR)$(STEADPATH)/stead.lua
	$(RM) $(DESTDIR)$(STEADPATH)/gui.lua

=== src/sdl-instead/CMakeLists.txt ===
# sources
SET(INSTEAD_SRCS
	SDL_anigif.c
	SDL_gfxBlitFunc.c
	SDL_rotozoom.c
	cache.c
	config.c
	game.c
	graphics.c
	idf.c
	input.c
	instead.c
	ioapi.c
	lfs.c
	main.c
	menu.c
	sound.c
	themes.c
	tinymt32.c
	unpack.c
	unzip.c
	util.c
	list.c
)

# platform-specific sources
IF(APPLE)
	SET(INSTEAD_SRCS ${INSTEAD_SRCS} macosx.m)
	ADD_DEFINITIONS(-Dunix)
ELSEIF(WIN32 AND WINCE)
	SET(INSTEAD_SRCS ${INSTEAD_SRCS} wince.c iowin32.c)
ELSEIF(WIN32 AND NOT WINCE)
	SET(INSTEAD_SRCS ${INSTEAD_SRCS} windows.c iowin32.c)
ELSEIF(UNIX)
	SET(INSTEAD_SRCS ${INSTEAD_SRCS} unix.c)
	ADD_DEFINITIONS(-Dunix)
ELSE(APPLE)
	MESSAGE(FATAL_ERROR "Your platform is not supported yet, sorry")
ENDIF(APPLE)

# flags
ADD_DEFINITIONS(
	-DVERSION=\"${INSTEAD_VERSION}\"
	-D_USE_UNPACK
	-Wall
)

INCLUDE(CheckCXXCompilerFlag)
CHECK_CXX_COMPILER_FLAG(-Wextra WEXTRA_FLAG_SUPPORTED)
CHECK_CXX_COMPILER_FLAG(-Wno-unused-parameter WNO_UNUSED_PARAMETER_FLAG_SUPPORTED)

IF(WEXTRA_FLAG_SUPPORTED)
	ADD_DEFINITIONS(-Wextra)
ENDIF(WEXTRA_FLAG_SUPPORTED)

IF(WNO_UNUSED_PARAMETER_FLAG_SUPPORTED)
	ADD_DEFINITIONS(-Wno-unused-parameter)
ENDIF(WNO_UNUSED_PARAMETER_FLAG_SUPPORTED)

IF(SYSTEMWIDE)
	# Systemwide installation, global data paths
	ADD_DEFINITIONS(
		-DLANG_PATH=\"${CMAKE_INSTALL_PREFIX}/${LANGDIR}/\"
		-DSTEAD_PATH=\"${CMAKE_INSTALL_PREFIX}/${STEADDIR}/\"
		-DGAMES_PATH=\"${CMAKE_INSTALL_PREFIX}/${GAMESDIR}/\"
		-DTHEMES_PATH=\"${CMAKE_INSTALL_PREFIX}/${THEMESDIR}/\"
		-DICON_PATH=\"${CMAKE_INSTALL_PREFIX}/${ICONDIR}/\"
	)
ELSEIF(STANDALONE)
	# Standalone installation, local data paths
	ADD_DEFINITIONS(
		-DLANG_PATH=\"lang/\"
		-DSTEAD_PATH=\"stead/\"
		-DGAMES_PATH=\"games/\"
		-DTHEMES_PATH=\"themes/\"
		-DICON_PATH=\"icon/\"
		-D_LOCAL_APPDATA
	)
ELSE(SYSTEMWIDE)
	# Neither, data paths point to source tree
	ADD_DEFINITIONS(
		-DLANG_PATH=\"${CMAKE_SOURCE_DIR}/lang/\"
		-DSTEAD_PATH=\"${CMAKE_SOURCE_DIR}/stead/\"
		-DGAMES_PATH=\"${CMAKE_SOURCE_DIR}/games/\"
		-DTHEMES_PATH=\"${CMAKE_SOURCE_DIR}/themes/\"
		-DICON_PATH=\"${CMAKE_SOURCE_DIR}/icon/\"
	)
ENDIF(SYSTEMWIDE)

# depends
FIND_PACKAGE(Lua51 REQUIRED)
FIND_PACKAGE(ZLIB REQUIRED)
FIND_LIBRARY(MATH_LIBRARY m)

INCLUDE_DIRECTORIES(
	${ZLIB_INCLUDE_DIRS}
	${LUA_INCLUDE_DIR}
)

SET(INSTEAD_LIBS
	${ZLIB_LIBRARIES}
	${LUA_LIBRARIES}
	${MATH_LIBRARY}
)

IF(WITH_SDL2)
	FIND_PACKAGE(SDL2 REQUIRED)
	FIND_PACKAGE(SDL2_mixer REQUIRED)
	FIND_PACKAGE(SDL2_image REQUIRED)
	FIND_PACKAGE(SDL2_ttf REQUIRED)

	INCLUDE_DIRECTORIES(
		${SDL2_INCLUDE_DIR}
		${SDL2MIXER_INCLUDE_DIR}
		${SDL2IMAGE_INCLUDE_DIR}
		${SDL2TTF_INCLUDE_DIR}
	)

	LIST(APPEND INSTEAD_LIBS
		${SDL2_LIBRARY}
		${SDL2MIXER_LIBRARY}
		${SDL2IMAGE_LIBRARY}
		${SDL2TTF_LIBRARY}
	)
ELSE(WITH_SDL2)
	FIND_PACKAGE(SDL REQUIRED)
	FIND_PACKAGE(SDL_mixer REQUIRED)
	FIND_PACKAGE(SDL_image REQUIRED)
	FIND_PACKAGE(SDL_ttf REQUIRED)

	INCLUDE_DIRECTORIES(
		${SDL_INCLUDE_DIR}
		${SDLMIXER_INCLUDE_DIR}
		${SDLIMAGE_INCLUDE_DIR}
		${SDLTTF_INCLUDE_DIR}
	)

	LIST(APPEND INSTEAD_LIBS
		${SDL_LIBRARY}
		${SDLMIXER_LIBRARY}
		${SDLIMAGE_LIBRARY}
		${SDLTTF_LIBRARY}
	)
ENDIF(WITH_SDL2)

IF(WITH_ICONV)
	FIND_PACKAGE(Iconv REQUIRED)
	ADD_DEFINITIONS(-D_HAVE_ICONV)
	INCLUDE_DIRECTORIES(${ICONV_INCLUDE_DIR})
	SET(INSTEAD_LIBS ${INSTEAD_LIBS} ${ICONV_LIBRARY})
ENDIF(WITH_ICONV)

IF(WITH_GTK2)
	FIND_PACKAGE(GTK2 REQUIRED)
	ADD_DEFINITIONS(-D_USE_GTK -D_USE_BROWSE ${GTK2_DEFINITIONS})
	INCLUDE_DIRECTORIES(${GTK2_INCLUDE_DIRS})
	SET(INSTEAD_LIBS ${INSTEAD_LIBS} ${GTK2_LIBRARIES})
ELSEIF(WITH_GTK3)
	FIND_PACKAGE(GTK3 REQUIRED)
	ADD_DEFINITIONS(-D_USE_GTK -D_USE_BROWSE)
	INCLUDE_DIRECTORIES(${GTK3_INCLUDE_DIRS})
	SET(INSTEAD_LIBS ${INSTEAD_LIBS} ${GTK3_LIBRARIES})
ENDIF(WITH_GTK2)

# targets
ADD_EXECUTABLE(sdl-instead ${INSTEAD_SRCS})
TARGET_LINK_LIBRARIES(sdl-instead ${INSTEAD_LIBS})

# install
INCLUDE(InstallSymlink)

IF(SYSTEMWIDE)
	INSTALL(TARGETS sdl-instead DESTINATION ${BINDIR})
	INSTALL_SYMLINK(sdl-instead instead${CMAKE_EXECUTABLE_SUFFIX} ${BINDIR})
ELSEIF(STANDALONE)
	INSTALL(TARGETS sdl-instead DESTINATION ${STANDALONEDIR})
	INSTALL_SYMLINK(sdl-instead instead${CMAKE_EXECUTABLE_SUFFIX} ${STANDALONEDIR})
ENDIF(SYSTEMWIDE)

=== src/sdl-instead/Makefile ===
include ../../Rules.make
include ../../config.make

CFLAGS += $(SDL_CFLAGS) $(LUA_CFLAGS) $(ZLIB_CFLAGS) $(EXTRA_CFLAGS) -DLANG_PATH=\"${LANGPATH}/\" -DSTEAD_PATH=\"${STEADPATH}/\"  -DGAMES_PATH=\"${GAMESPATH}/\" -DTHEMES_PATH=\"${THEMESPATH}/\" -DVERSION=\"$(VERSION)\" -DICON_PATH=\"${ICONPATH}/\"

LDFLAGS += $(SDL_LFLAGS) $(LUA_LFLAGS) $(ZLIB_LFLAGS) $(EXTRA_LDFLAGS)
 
SRC     := graphics.c input.c game.c main.c instead.c sound.c SDL_rotozoom.c SDL_anigif.c SDL_gfxBlitFunc.c config.c themes.c menu.c util.c list.c cache.c unzip.c ioapi.c unpack.c lfs.c idf.c tinymt32.c $(PLATFORM)
H	:= cache.h config.h externals.h game.h graphics.h input.h instead.h internals.h ioapi.h iowin32.h list.h \
	menu.h SDL_rotozoom.h SDL_anigif.h SDL_gfxBlitFunc.h sound.h themes.h unzip.h util.h tinymt32.h

OBJ     := $(patsubst %.c, %.o, $(SRC)) $(ADDOBJ)

all: sdl-instead$(EXE)

$(OBJ): %.o : %.c $(H)
	$(CC) -c $(<) $(I) $(CFLAGS) $(CPPFLAGS)

sdl-instead$(EXE):  $(OBJ) $(RESOURCES)
	$(CC) $(CFLAGS) $(^) $(LDFLAGS) -o $(@) 

install:
	$(INSTALLD) $(DESTDIR)$(BIN)
	$(INSTALLB) sdl-instead$(EXE) $(DESTDIR)$(BIN)/sdl-instead$(EXE)
	$(LN) sdl-instead$(EXE) $(DESTDIR)$(BIN)/instead$(EXE)

uninstall:
	$(RM) $(DESTDIR)$(BIN)/sdl-instead$(EXE)
	$(RM) $(DESTDIR)$(BIN)/instead$(EXE)

clean:
	$(RM) -f *.o sdl-instead$(EXE)

=== debian/changelog ===
instead (2.4.1) unstable; urgency=low
  * 2.4.1 release;

 -- Peter Kosyh <p.kosyh@gmail.com>  Sat, 16 Apr 2016 13:50:00 +0300

instead (2.4.0) unstable; urgency=low
  * 2.4.0 release;

 -- Peter Kosyh <p.kosyh@gmail.com>  Thu, 18 Feb 2016 15:09:00 +0300

instead (2.3.0) unstable; urgency=low
  * 2.3.0 release;

 -- Peter Kosyh <p.kosyh@gmail.com>  Sun, 18 Oct 2015 13:15:00 +0300

instead (2.2.7) unstable; urgency=low
  * 2.2.7 release;

 -- Peter Kosyh <p.kosyh@gmail.com>  Sun, 20 Sep 2015 13:49:00 +0300

instead (2.2.6) unstable; urgency=low
  * 2.2.6 release;

 -- Peter Kosyh <p.kosyh@gmail.com>  Sun, 20 Sep 2015 13:22:00 +0300

instead (2.2.5) unstable; urgency=low
  * 2.2.5 release;

 -- Peter Kosyh <p.kosyh@gmail.com>  Sun, 30 Aug 2015 16:15:00 +0300

instead (2.2.4) unstable; urgency=low
  * 2.2.4 release;

 -- Peter Kosyh <p.kosyh@gmail.com>  Sun, 2 Aug 2015 11:22:00 +0300

instead (2.2.3) unstable; urgency=low
  * 2.2.3 release;

 -- Peter Kosyh <p.kosyh@gmail.com>  Fri, 20 Mar 2015 18:56:00 +0300

instead (2.2.2) unstable; urgency=low
  * 2.2.2 release;

 -- Peter Kosyh <p.kosyh@gmail.com>  Fri, 6 Feb 2015 19:17:00 +0300

instead (2.2.1) unstable; urgency=low
  * 2.2.1 release;

 -- Peter Kosyh <p.kosyh@gmail.com>  Sat, 31 Jan 2015 16:27:00 +0300

instead (2.2.0) unstable; urgency=low
  * 2.2.0 release;

 -- Peter Kosyh <p.kosyh@gmail.com>  Thu, 1 Jan 2015 10:52:00 +0300

instead (2.1.1) unstable; urgency=low
  * 2.1.1 release;

 -- Peter Kosyh <p.kosyh@gmail.com>  Wed, 9 Jul 2014 13:30:00 +0400

instead (2.1.0) unstable; urgency=low
  * 2.1.0 release;

 -- Peter Kosyh <p.kosyh@gmail.com>  Tue, 3 Jun 2014 17:28:00 +0400

instead (2.0.3) unstable; urgency=low
  * 2.0.3 release;

 -- Peter Kosyh <p.kosyh@gmail.com>  Thu, 20 Feb 2014 17:20:00 +0400

instead (2.0.2) unstable; urgency=low
  * 2.0.2 release;

 -- Peter Kosyh <p.kosyh@gmail.com>  Thu, 30 Jan 2014 08:30:00 +0400

instead (2.0.1) unstable; urgency=low
  * 2.0.1 release;

 -- Peter Kosyh <p.kosyh@gmail.com>  Mon, 27 Jan 2014 19:40:00 +0400

instead (2.0.0) unstable; urgency=low
  * 2.0.0 release;

 -- Peter Kosyh <p.kosyh@gmail.com>  Sun, 26 Jan 2014 13:12:00 +0400

instead (1.9.1) unstable; urgency=low
  * 1.9.1 release;

 -- Peter Kosyh <p.kosyh@gmail.com>  Sat, 13 Jul 2013 14:30:00 +0400

instead (1.9.0) unstable; urgency=low
  * 1.9.0 release;

 -- Peter Kosyh <p.kosyh@gmail.com>  Fri, 12 Apr 2013 08:00:00 +0400

instead (1.8.3) unstable; urgency=low
  * debian friendly release;

 -- Peter Kosyh <p.kosyh@gmail.com>  Sat, 26 Jan 2013 14:52:00 +0400

## instead 3.1.2

=== CMakeLists.txt ===
--- 
+++ 
@@ -8,7 +8,7 @@
 ENDIF("${PROJECT_SOURCE_DIR}" STREQUAL "${PROJECT_BINARY_DIR}")
 
 # global constants
-SET(INSTEAD_VERSION "2.4.1")
+SET(INSTEAD_VERSION "3.1.2")
 
 # options
 OPTION(WITH_SDL2 "Use SDL2 instead of SDL 1" OFF)
@@ -30,7 +30,8 @@
 OPTION(STANDALONE "Build for standalone package creation" OFF)
 
 IF(WITH_GTK2 AND WITH_GTK3)
-	MESSAGE(FATAL_ERROR "WITH_GTK2 and WITH_GTK3 are mutually exclusive")
+	MESSAGE(WARNING "WITH_GTK2 and WITH_GTK3 are mutually exclusive, disabling WITH_GTK2")
+	SET(WITH_GTK2 OFF)
 ENDIF(WITH_GTK2 AND WITH_GTK3)
 
 IF(SYSTEMWIDE AND STANDALONE)
@@ -57,6 +58,6 @@
 ADD_SUBDIRECTORY(games)
 ADD_SUBDIRECTORY(icon)
 ADD_SUBDIRECTORY(lang)
-ADD_SUBDIRECTORY(src/sdl-instead)
+ADD_SUBDIRECTORY(src)
 ADD_SUBDIRECTORY(stead)
 ADD_SUBDIRECTORY(themes)

=== Makefile ===
--- 
+++ 
@@ -4,7 +4,7 @@
 VERTITLE := instead-$(VERSION)
 ARCHIVE := instead_$(VERSION).tar.gz#
 
-SUBDIRS += src/sdl-instead stead games themes icon desktop doc lang
+SUBDIRS += src/ stead games themes icon desktop doc lang
 
 all:
 	@for dir in $(SUBDIRS); do \

=== doc/CMakeLists.txt ===
--- 
+++ 
@@ -3,10 +3,11 @@
 )
 
 SET(GENERATED_DOC_FILES
-	instead-manual-en.html
-	instead-manual.html
-	instead-manual.pdf
-	instead-modules.pdf
+	stead3.pdf
+	stead2.pdf
+	stead2-modules.pdf
+	stead2-en.html
+	stead2.html
 	instead.txt
 )

=== doc/Makefile ===
include ../Rules.make
include ../config.make

all:

clean:
	rm -f *.pdf *.aux *.log *.out *.toc stead3-manual.tex stead2.html stead2-en.html instead.txt

stead3-manual.tex: stead3.md
	multimarkdown stead3.md -t latex -o stead3-manual.tex

stead3.pdf: stead3.tex stead3-manual.tex
	xelatex stead3.tex
	xelatex stead3.tex
	xelatex stead3.tex

pdf:	stead3.pdf stead2-pdfs

stead2-pdfs:
	./makepdfs2

man:
	man ./instead.6 | col -b > instead.txt

wiki:
	wget "http://instead.syscall.ru/wiki/doku.php?id=ru:gamedev:documentation&do=export_xhtml" -O stead2.html
	wget "http://instead.syscall.ru/wiki/doku.php?id=en:gamedev:documentation&do=export_xhtml" -O stead2-en.html

docs:	wiki man pdf

install:
	$(INSTALLD) $(DESTDIR)$(DOCPATH)
	-$(INSTALL) instead.txt *.html *.pdf $(DESTDIR)$(DOCPATH)

	$(INSTALLD) $(DESTDIR)$(MANPATH)
	$(INSTALL) *.6 $(DESTDIR)$(MANPATH)

uninstall:
	$(RM) -rf $(DESTDIR)$(DOCPATH)
	$(RM) $(DESTDIR)$(MANPATH)/instead.*

=== src/CMakeLists.txt ===
# sources
SET(INSTEAD_SRCS
	SDL_anigif.c
	SDL_gfxBlitFunc.c
	SDL_rotozoom.c
	config.c
	game.c
	graphics.c
	input.c
	noise1234.c
	ioapi.c
	main.c
	menu.c
	sound.c
	themes.c
	unpack.c
	unzip.c
	utils.c
	instead_bits.c
	instead_sprites.c
	instead_timer.c
	instead_sound.c
	instead_paths.c
	instead/instead.c
	instead/util.c
	instead/list.c
	instead/cache.c
	instead/idf.c
	instead/tinymt32.c
	instead/lfs.c
)

# platform-specific sources
IF(APPLE)
	SET(INSTEAD_SRCS ${INSTEAD_SRCS} macosx.m)
	ADD_DEFINITIONS(-Dunix)
ELSEIF(WIN32 AND WINCE)
	SET(INSTEAD_SRCS ${INSTEAD_SRCS} wince.c iowin32.c)
ELSEIF(WIN32 AND NOT WINCE)
	SET(INSTEAD_SRCS ${INSTEAD_SRCS} windows.c iowin32.c)
ELSEIF(UNIX)
	SET(INSTEAD_SRCS ${INSTEAD_SRCS} unix.c)
	ADD_DEFINITIONS(-Dunix)
ELSE(APPLE)
	MESSAGE(FATAL_ERROR "Your platform is not supported yet, sorry")
ENDIF(APPLE)

# flags
ADD_DEFINITIONS(
	-DVERSION=\"${INSTEAD_VERSION}\"
	-D_USE_UNPACK
	-Wall
	-D_USE_SDL
)

INCLUDE(CheckCXXCompilerFlag)
CHECK_CXX_COMPILER_FLAG(-Wextra WEXTRA_FLAG_SUPPORTED)
CHECK_CXX_COMPILER_FLAG(-Wno-unused-parameter WNO_UNUSED_PARAMETER_FLAG_SUPPORTED)

IF(WEXTRA_FLAG_SUPPORTED)
	ADD_DEFINITIONS(-Wextra)
ENDIF(WEXTRA_FLAG_SUPPORTED)

IF(WNO_UNUSED_PARAMETER_FLAG_SUPPORTED)
	ADD_DEFINITIONS(-Wno-unused-parameter)
ENDIF(WNO_UNUSED_PARAMETER_FLAG_SUPPORTED)

IF(SYSTEMWIDE)
	# Systemwide installation, global data paths
	ADD_DEFINITIONS(
		-DLANG_PATH=\"${CMAKE_INSTALL_PREFIX}/${LANGDIR}/\"
		-DSTEAD_PATH=\"${CMAKE_INSTALL_PREFIX}/${STEADDIR}/\"
		-DGAMES_PATH=\"${CMAKE_INSTALL_PREFIX}/${GAMESDIR}/\"
		-DTHEMES_PATH=\"${CMAKE_INSTALL_PREFIX}/${THEMESDIR}/\"
		-DICON_PATH=\"${CMAKE_INSTALL_PREFIX}/${ICONDIR}/\"
	)
ELSEIF(STANDALONE)
	# Standalone installation, local data paths
	ADD_DEFINITIONS(
		-DLANG_PATH=\"lang/\"
		-DSTEAD_PATH=\"stead/\"
		-DGAMES_PATH=\"games/\"
		-DTHEMES_PATH=\"themes/\"
		-DICON_PATH=\"icon/\"
		-D_LOCAL_APPDATA
	)
ELSE(SYSTEMWIDE)
	# Neither, data paths point to source tree
	ADD_DEFINITIONS(
		-DLANG_PATH=\"${CMAKE_SOURCE_DIR}/lang/\"
		-DSTEAD_PATH=\"${CMAKE_SOURCE_DIR}/stead/\"
		-DGAMES_PATH=\"${CMAKE_SOURCE_DIR}/games/\"
		-DTHEMES_PATH=\"${CMAKE_SOURCE_DIR}/themes/\"
		-DICON_PATH=\"${CMAKE_SOURCE_DIR}/icon/\"
	)
ENDIF(SYSTEMWIDE)

# depends
FIND_PACKAGE(Lua51 REQUIRED)
FIND_PACKAGE(ZLIB REQUIRED)
FIND_LIBRARY(MATH_LIBRARY m)

INCLUDE_DIRECTORIES(
	${ZLIB_INCLUDE_DIRS}
	${LUA_INCLUDE_DIR}
)

SET(INSTEAD_LIBS
	${ZLIB_LIBRARIES}
	${LUA_LIBRARIES}
	${MATH_LIBRARY}
)

IF(WITH_SDL2)
	FIND_PACKAGE(SDL2 REQUIRED)
	FIND_PACKAGE(SDL2_mixer REQUIRED)
	FIND_PACKAGE(SDL2_image REQUIRED)
	FIND_PACKAGE(SDL2_ttf REQUIRED)

	INCLUDE_DIRECTORIES(
		${SDL2_INCLUDE_DIR}
		${SDL2MIXER_INCLUDE_DIR}
		${SDL2IMAGE_INCLUDE_DIR}
		${SDL2TTF_INCLUDE_DIR}
	)

	LIST(APPEND INSTEAD_LIBS
		${SDL2_LIBRARY}
		${SDL2MIXER_LIBRARY}
		${SDL2IMAGE_LIBRARY}
		${SDL2TTF_LIBRARY}
	)
ELSE(WITH_SDL2)
	FIND_PACKAGE(SDL REQUIRED)
	FIND_PACKAGE(SDL_mixer REQUIRED)
	FIND_PACKAGE(SDL_image REQUIRED)
	FIND_PACKAGE(SDL_ttf REQUIRED)

	INCLUDE_DIRECTORIES(
		${SDL_INCLUDE_DIR}
		${SDLMIXER_INCLUDE_DIR}
		${SDLIMAGE_INCLUDE_DIR}
		${SDLTTF_INCLUDE_DIR}
	)

	LIST(APPEND INSTEAD_LIBS
		${SDL_LIBRARY}
		${SDLMIXER_LIBRARY}
		${SDLIMAGE_LIBRARY}
		${SDLTTF_LIBRARY}
	)
ENDIF(WITH_SDL2)

IF(WITH_ICONV)
	FIND_PACKAGE(Iconv REQUIRED)
	ADD_DEFINITIONS(-D_HAVE_ICONV)
	INCLUDE_DIRECTORIES(${ICONV_INCLUDE_DIR})
	SET(INSTEAD_LIBS ${INSTEAD_LIBS} ${ICONV_LIBRARY})
ENDIF(WITH_ICONV)

IF(WITH_GTK2)
	FIND_PACKAGE(GTK2 REQUIRED)
	ADD_DEFINITIONS(-D_USE_GTK -D_USE_BROWSE ${GTK2_DEFINITIONS})
	INCLUDE_DIRECTORIES(${GTK2_INCLUDE_DIRS})
	SET(INSTEAD_LIBS ${INSTEAD_LIBS} ${GTK2_LIBRARIES})
ELSEIF(WITH_GTK3)
	FIND_PACKAGE(GTK3 REQUIRED)
	ADD_DEFINITIONS(-D_USE_GTK -D_USE_BROWSE)
	INCLUDE_DIRECTORIES(${GTK3_INCLUDE_DIRS})
	SET(INSTEAD_LIBS ${INSTEAD_LIBS} ${GTK3_LIBRARIES})
ENDIF(WITH_GTK2)

# targets
ADD_EXECUTABLE(sdl-instead ${INSTEAD_SRCS})
TARGET_LINK_LIBRARIES(sdl-instead ${INSTEAD_LIBS})

# install
INCLUDE(InstallSymlink)

IF(SYSTEMWIDE)
	INSTALL(TARGETS sdl-instead DESTINATION ${BINDIR})
	INSTALL_SYMLINK(sdl-instead instead${CMAKE_EXECUTABLE_SUFFIX} ${BINDIR})
ELSEIF(STANDALONE)
	INSTALL(TARGETS sdl-instead DESTINATION ${STANDALONEDIR})
	INSTALL_SYMLINK(sdl-instead instead${CMAKE_EXECUTABLE_SUFFIX} ${STANDALONEDIR})
ENDIF(SYSTEMWIDE)

=== src/tiny/Makefile ===
include ../../Rules.make.standalone
include ../../config.make

CFLAGS += $(LUA_CFLAGS) $(EXTRA_CFLAGS) -DSTEAD_PATH=\"${STEADPATH}/\" -DVERSION=\"$(VERSION)\"

LDFLAGS += $(LUA_LFLAGS) $(EXTRA_LDFLAGS)

INSTEAD_SRC	:= instead.c util.c list.c cache.c idf.c tinymt32.c lfs.c

SRC     := $(INSTEAD_SRC)
OBJ     := $(patsubst %.c, %.o, $(SRC))

all: instead stead tiny-instead$(EXE)

$(OBJ): %.o : instead/%.c
	$(CC) -c $(<) $(I) $(CFLAGS) $(CPPFLAGS) -o $(@)

tiny-instead$(EXE): main.c $(OBJ)
	$(CC) $(CFLAGS) $(^) $(LDFLAGS) -o $(@)

instead:
	ln -s ../instead instead

stead:
	ln -s ../../stead stead

clean:
	$(RM) -f *.o instead stead tiny-instead$(EXE)

=== debian/changelog ===
instead (3.1.2-2) unstable; urgency=low

  * Remove menu entry.
  * Add instead-doc-base to Conflicts and Replaces sections of
    instead-doc-common.
  * Fix build on Hurd systems (Closes: #873542).

 -- Sam Protsenko <joe.skb7@gmail.com>  Tue, 29 Aug 2017 00:39:00 +0300

instead (3.1.2-1) unstable; urgency=low

  * New upstream release (Closes: #867540).
  * Fixed fonts dependencies (Closes: #861047).
  * Rename instead-doc-base -> instead-doc-common.
  * Use SDL2 instead of SDL1.
  * debian/control:
    - Bump Standards-Version up to 4.0.0.
    - Increase debhelper version up to 9.
  * debian/rules:
    - Move to CMake.
    - Simplify rules script.
  * debian/copyright:
    - Change copyrights w.r.t. to new INSTEAD version.

 -- Sam Protsenko <joe.skb7@gmail.com>  Mon, 21 Aug 2017 13:21:00 +0300

=== debian/control ===
Source: instead
Section: games
Priority: optional
Maintainer: Sam Protsenko <joe.skb7@gmail.com>
Build-Depends: debhelper (>= 9), dpkg-dev (>= 1.16.1~), pkg-config,
 cmake (>= 2.6.0), liblua5.1-dev, zlib1g-dev, libgtk2.0-dev,
 libsdl2-dev, libsdl2-mixer-dev, libsdl2-image-dev, libsdl2-ttf-dev
Standards-Version: 4.0.0
Homepage: http://instead.sourceforge.net

Package: instead
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, instead-data (= ${source:Version})
Suggests: instead-doc-en | instead-doc-ru
Description: Simple text adventures/visual novels engine
 INSTEAD -- INterpreter of Simple TExt ADventure.
 Using INSTEAD you can create and play games that could be classified
 as a mix of visual novel and text quest.
 .
 Features:
   * Simple story source code (Lua-based script)
   * GUI interface that supports music and pictures
   * Theme support
   * Portability (INSTEAD depends on SDL and Lua)
 .
 Game repository: http://instead-games.sourceforge.net

Package: instead-data
Architecture: all
Depends: ${misc:Depends}, fonts-liberation
Recommends: instead
Description: Data files for INSTEAD
 INSTEAD -- INterpreter of Simple TExt ADventure.
 Using INSTEAD you can create and play games that could be classified
 as a mix of visual novel and text quest.
 .
 Features:
   * Simple story source code (Lua-based script)
   * GUI interface that supports music and pictures
   * Theme support
   * Portability (INSTEAD depends on SDL and Lua)
 .
 This package contains language files, graphical themes, STEAD scripts
 and tutorial.

Package: instead-doc-common
Section: doc
Architecture: all
Depends: ${misc:Depends}
Replaces: instead-doc-base
Conflicts: instead-doc-base
Description: Common documentation for INSTEAD
 This package contains base documentation (common for all languages).
 .
 At the moment this contains only examples for developer's manual.
 These examples (written in Lua) demonstrate how to implement
 common features when you write a game for INSTEAD.

Package: instead-doc-en
Section: doc
Architecture: all
Depends: ${misc:Depends}, instead-doc-common (= ${source:Version})
Description: English documentation for INSTEAD
 This package contains game developer manual and examples in English.
 Manual describes basic API in Lua and how to create games for INSTEAD engine.
 .
 Unfortunately, complete and latest documentation currently available only
 in Russian.

Package: instead-doc-ru
Section: doc
Architecture: all
Depends: ${misc:Depends}, instead-doc-common (= ${source:Version})
Description: Russian documentation for INSTEAD
 This package contains game developer manual and examples in Russian.
 Manual describes basic API in Lua and how to create games for INSTEAD engine.
 .
 Russian documentation is complete and up to date, so it's preferred to use it.

=== debian/rules ===
#!/usr/bin/make -f

# Output every command that modifies files on the build system
#export DH_VERBOSE = 1

# Enable all hardening options
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

# Do not link against unused libraries brought by GTK+2.0 dependency
export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed -Wl,--no-undefined

# Install INSTEAD to /usr/games rather than to /usr/bin
BINDIR = games
# Put data into /usr/share/games/instead rather than /usr/share/instead
DATADIR = share/games/instead
# Configure CMake build
CMAKE_FLAGS = -DWITH_SDL2=1
# Override some variables in CMakeLists.txt
CMAKE_CACHE_FLAGS = -DBINDIR=$(BINDIR) -DDATADIR=$(DATADIR)

%:
	dh $@ --buildsystem=cmake --parallel

override_dh_auto_configure:
	dh_auto_configure -- $(CMAKE_FLAGS) $(CMAKE_CACHE_FLAGS)

override_dh_compress:
	dh_compress --exclude=.pdf --exclude=.lua

## instead 3.2.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -8,10 +8,10 @@
 ENDIF("${PROJECT_SOURCE_DIR}" STREQUAL "${PROJECT_BINARY_DIR}")
 
 # global constants
-SET(INSTEAD_VERSION "3.1.2")
+SET(INSTEAD_VERSION "3.2.1")
 
 # options
-OPTION(WITH_SDL2 "Use SDL2 instead of SDL 1" OFF)
+OPTION(WITH_SDL2 "Use SDL2 instead of SDL 1" ON)
 OPTION(WITH_GTK2 "Use GTK2 file open dialog" ON)
 OPTION(WITH_GTK3 "Use GTK3 file open dialog" OFF)
 OPTION(WITH_ICONV "Build with iconv support" ON)

=== doc/CMakeLists.txt ===
--- 
+++ 
@@ -1,13 +1,10 @@
 SET(DOC_FILES
-	index.html
+	
 )
 
 SET(GENERATED_DOC_FILES
 	stead3.pdf
-	stead2.pdf
-	stead2-modules.pdf
-	stead2-en.html
-	stead2.html
+	modules3.pdf
 	instead.txt
 )

=== doc/Makefile ===
include ../Rules.make
include ../config.make

all:

clean:
	rm -f *.aux *.log *.out *.toc stead3-manual.tex modules3-manual.tex
	rm -f *.pdf instead.txt

stead3-manual.tex: stead3.md
	multimarkdown stead3.md -t latex -o stead3-manual.tex

stead3.pdf: stead3.tex stead3-manual.tex
	xelatex stead3.tex
	xelatex stead3.tex
	xelatex stead3.tex

modules3-manual.tex: modules3.md
	multimarkdown modules3.md -t latex -o modules3-manual.tex

modules3.pdf: modules3.tex modules3-manual.tex
	xelatex modules3.tex
	xelatex modules3.tex
	xelatex modules3.tex

pdf:	stead3.pdf modules3.pdf
	rm -f *.aux *.log *.out *.toc stead3-manual.tex modules3-manual.tex

man:
	man ./instead.6 | col -b > instead.txt

docs:	man pdf

install:
	$(INSTALLD) $(DESTDIR)$(DOCPATH)
	-$(INSTALL) instead.txt *.pdf $(DESTDIR)$(DOCPATH)

	$(INSTALLD) $(DESTDIR)$(MANPATH)
	$(INSTALL) *.6 $(DESTDIR)$(MANPATH)

uninstall:
	$(RM) -rf $(DESTDIR)$(DOCPATH)
	$(RM) $(DESTDIR)$(MANPATH)/instead.*

=== icon/CMakeLists.txt ===
SET(ICON_FILES
	sdl_instead.png
	sdl_instead.ico
	sdl_instead.svg
)

IF(WIN32)
	SET(PLATFORM_ICON_FILE sdl_instead_1x32.png)
ELSE(WIN32)
	SET(PLATFORM_ICON_FILE sdl_instead_1.png)
ENDIF(WIN32)

IF(SYSTEMWIDE)
	INSTALL(FILES ${ICON_FILES} DESTINATION ${ICONDIR})
	INSTALL(FILES ${PLATFORM_ICON_FILE} DESTINATION ${ICONDIR} RENAME sdl_instead_1.png)
ELSEIF(STANDALONE)
	INSTALL(FILES ${ICON_FILES} DESTINATION ${STANDALONEDIR}/icon)
	INSTALL(FILES ${PLATFORM_ICON_FILE} DESTINATION ${STANDALONEDIR}/icon RENAME sdl_instead_1.png)
ENDIF(SYSTEMWIDE)

=== lang/CMakeLists.txt ===
IF(SYSTEMWIDE)
	FILE(GLOB FILES "*.ini")
	INSTALL(FILES ${FILES} DESTINATION ${LANGDIR})
ELSEIF(STANDALONE)
	FILE(GLOB FILES "*.ini")
	INSTALL(FILES ${FILES} DESTINATION ${STANDALONEDIR}/lang)
ENDIF(SYSTEMWIDE)

=== lang/Makefile ===
include ../Rules.make
include ../config.make

clean:
all:
install:
	$(INSTALLD) $(DESTDIR)$(LANGPATH)
	for f in *.ini; do \
		$(INSTALL) $$f $(DESTDIR)$(LANGPATH)/$$f;\
	done

uninstall:
	$(RM) -rf $(DESTDIR)$(LANGPATH)

=== themes/CMakeLists.txt ===
SET(THEMES arctic bluesteel book clearlooks default fantasy original wide)

IF(SYSTEMWIDE)
	FOREACH(THEME ${THEMES})
		INSTALL(DIRECTORY ${THEME} DESTINATION ${THEMESDIR} PATTERN ".svn" EXCLUDE)
	ENDFOREACH(THEME)
ELSEIF(STANDALONE)
	FOREACH(THEME ${THEMES})
		INSTALL(DIRECTORY ${THEME} DESTINATION ${STANDALONEDIR}/themes PATTERN ".svn" EXCLUDE)
	ENDFOREACH(THEME)
ENDIF(SYSTEMWIDE)

=== debian/changelog ===
instead (3.2.1-1) unstable; urgency=low

  * New upstream release (Closes: #896061).
  * Remove doc packages (until English translation of new doc is out).
  * debian/compat:
    - Update debhelper version (from 9 to 11).
  * debian/control:
    - Bump Standards-Version up to 4.1.4.
    - Increase debhelper version up to 11.
    - Replace liblua5.1-dev with liblua5.1-0-dev.
    - Update links for "Homepage" and "Game repository".
    - Remove doc packages (see above).
    - Remove "Suggests: instead-doc-*" (see above).
  * debian/copyright:
    - Remove the entry for doc/examples/sfxr.lua file as it was removed
      upstream.
    - Update copyright dates (from 2017 to 2018).
    - Update licenses links (use https instead of http).
  * debian/patches:
    - Remove fix-hurd-build patch (fixed upstream).
  * debian/rules:
    - Remove "--parallel" parameter.

 -- Sam Protsenko <joe.skb7@gmail.com>  Sun, 01 Jul 2018 20:02:00 +0300

=== debian/control ===
Source: instead
Section: games
Priority: optional
Maintainer: Sam Protsenko <joe.skb7@gmail.com>
Build-Depends: debhelper (>= 11), dpkg-dev (>= 1.16.1~), pkg-config,
 cmake (>= 2.6.0), liblua5.1-0-dev, zlib1g-dev, libgtk2.0-dev,
 libsdl2-dev, libsdl2-mixer-dev, libsdl2-image-dev, libsdl2-ttf-dev
Standards-Version: 4.1.4
Homepage: https://instead-hub.github.io/

Package: instead
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, instead-data (= ${source:Version})
Description: Simple text adventures/visual novels engine
 INSTEAD -- INterpreter of Simple TExt ADventure.
 Using INSTEAD you can create and play games that could be classified
 as a mix of visual novel and text quest.
 .
 Features:
   * Simple story source code (Lua-based script)
   * GUI interface that supports music and pictures
   * Theme support
   * Portability (INSTEAD depends on SDL and Lua)
 .
 Game repository: https://instead-hub.github.io/page/games/

Package: instead-data
Architecture: all
Depends: ${misc:Depends}, fonts-liberation
Recommends: instead
Description: Data files for INSTEAD
 INSTEAD -- INterpreter of Simple TExt ADventure.
 Using INSTEAD you can create and play games that could be classified
 as a mix of visual novel and text quest.
 .
 Features:
   * Simple story source code (Lua-based script)
   * GUI interface that supports music and pictures
   * Theme support
   * Portability (INSTEAD depends on SDL and Lua)
 .
 This package contains language files, graphical themes, STEAD scripts
 and tutorial.

=== debian/rules ===
--- 
+++ 
@@ -19,7 +19,7 @@
 CMAKE_CACHE_FLAGS = -DBINDIR=$(BINDIR) -DDATADIR=$(DATADIR)
 
 %:
-	dh $@ --buildsystem=cmake --parallel
+	dh $@ --buildsystem=cmake
 
 override_dh_auto_configure:
 	dh_auto_configure -- $(CMAKE_FLAGS) $(CMAKE_CACHE_FLAGS)

## instead 3.3.2

=== CMakeLists.txt ===
--- 
+++ 
@@ -8,13 +8,14 @@
 ENDIF("${PROJECT_SOURCE_DIR}" STREQUAL "${PROJECT_BINARY_DIR}")
 
 # global constants
-SET(INSTEAD_VERSION "3.2.1")
+SET(INSTEAD_VERSION "3.3.2")
 
 # options
 OPTION(WITH_SDL2 "Use SDL2 instead of SDL 1" ON)
 OPTION(WITH_GTK2 "Use GTK2 file open dialog" ON)
 OPTION(WITH_GTK3 "Use GTK3 file open dialog" OFF)
 OPTION(WITH_ICONV "Build with iconv support" ON)
+OPTION(WITH_LUAJIT "Use LuaJIT instead of Lua (recommended)" OFF)
 
 # Note: there are three build modes for instead:
 # - SYSTEMWIDE

=== Makefile ===
--- 
+++ 
@@ -40,7 +40,7 @@
 	wget "http://sourceforge.net/projects/instead/files/instead/build-bin-data/$(@)/download" -O $(@)
 
 windows-sdl2.tar.gz:
-	wget "http://sourceforge.net/projects/instead/files/instead/build-bin-data/$(@)/download" -O $(@)
+	wget "http://sourceforge.net/projects/instead/files/instead/build-bin-data/windows-sdl2.tar.gz/download" -O $(@)
 
 build-bin-data: caanoo.tar.gz mingw32ce.tar.gz windows-sdl2.tar.gz

=== desktop/Makefile ===
include ../Rules.make
include ../config.make

clean:
	rm -rf instead.desktop

all: instead.desktop

instead.desktop: instead.desktop.in
	cat instead.desktop.in | sed -e "s|@BIN@|$(BIN)|g" > instead.desktop

install:
	$(INSTALLD) $(DESTDIR)$(PREFIX)/share/applications
	$(INSTALL) instead.desktop $(DESTDIR)$(PREFIX)/share/applications/instead.desktop

uninstall:
	$(RM) $(DESTDIR)$(PREFIX)/share/applications/instead.desktop

=== doc/CMakeLists.txt ===
--- 
+++ 
@@ -3,8 +3,9 @@
 )
 
 SET(GENERATED_DOC_FILES
-	stead3.pdf
-	modules3.pdf
+	stead3-ru.pdf
+	modules3-ru.pdf
+	stead3-en.pdf
 	instead.txt
 )

=== doc/Makefile ===
include ../Rules.make
include ../config.make

all:

clean:
	rm -f *.aux *.log *.out *.toc stead3-manual-ru.tex modules3-manual-ru.tex stead3-manual-en.tex
#	rm -f *.pdf instead.txt

stead3-manual-ru.tex: stead3-ru.md
	multimarkdown stead3-ru.md -t latex -o stead3-manual-ru.tex

stead3-ru.pdf: stead3-ru.tex stead3-manual-ru.tex
	xelatex stead3-ru.tex
	xelatex stead3-ru.tex
	xelatex stead3-ru.tex

modules3-manual-ru.tex: modules3-ru.md
	multimarkdown modules3-ru.md -t latex -o modules3-manual-ru.tex

modules3-ru.pdf: modules3-ru.tex modules3-manual-ru.tex
	xelatex modules3-ru.tex
	xelatex modules3-ru.tex
	xelatex modules3-ru.tex

stead3-manual-en.tex: stead3-en.md
	multimarkdown stead3-en.md -t latex -o stead3-manual-en.tex

stead3-en.pdf: stead3-en.tex stead3-manual-en.tex
	xelatex stead3-en.tex
	xelatex stead3-en.tex
	xelatex stead3-en.tex

pdf:	stead3-ru.pdf modules3-ru.pdf stead3-en.pdf
	rm -f *.aux *.log *.out *.toc stead3-manual-ru.tex modules3-manual-ru.tex stead3-manual-en.tex

man:
	man ./instead.6 | col -b > instead.txt

docs:	man pdf

install:
	$(INSTALLD) $(DESTDIR)$(DOCPATH)
	-$(INSTALL) instead.txt *.pdf $(DESTDIR)$(DOCPATH)

	$(INSTALLD) $(DESTDIR)$(MANPATH)
	$(INSTALL) *.6 $(DESTDIR)$(MANPATH)

uninstall:
	$(RM) -rf $(DESTDIR)$(DOCPATH)
	$(RM) $(DESTDIR)$(MANPATH)/instead.*

=== games/CMakeLists.txt ===
SET(GAMES tutorial3)

IF(SYSTEMWIDE)
	FOREACH(GAME ${GAMES})
		INSTALL(DIRECTORY ${GAME} DESTINATION ${GAMESDIR} PATTERN ".svn" EXCLUDE)
	ENDFOREACH(GAME)
ELSEIF(STANDALONE)
	FOREACH(GAME ${GAMES})
		INSTALL(DIRECTORY ${GAME} DESTINATION ${STANDALONEDIR}/games PATTERN ".svn" EXCLUDE)
	ENDFOREACH(GAME)
ENDIF(SYSTEMWIDE)

=== icon/Makefile ===
include ../Rules.make
include ../config.make

clean:
all:
install:
	$(INSTALLD) $(DESTDIR)$(ICONPATH)
	$(INSTALL) sdl_instead.png $(DESTDIR)$(ICONPATH)
ifeq ($(WINDOWS), yes)
	$(INSTALL) sdl_instead_1x32.png $(DESTDIR)$(ICONPATH)/sdl_instead_1.png
else
	$(INSTALL) sdl_instead_1.png $(DESTDIR)$(ICONPATH)
endif
	$(INSTALL) sdl_instead.ico $(DESTDIR)$(ICONPATH)

uninstall:
	$(RM) $(DESTDIR)$(ICONPATH)/sdl_instead.png
	$(RM) $(DESTDIR)$(ICONPATH)/sdl_instead_1.png
	$(RM) $(DESTDIR)$(ICONPATH)/sdl_instead.ico

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -96,7 +96,12 @@
 ENDIF(SYSTEMWIDE)
 
 # depends
+IF(WITH_LUAJIT)
+FIND_PACKAGE(LuaJIT REQUIRED)
+ELSE(WITH_LUAJIT)
 FIND_PACKAGE(Lua51 REQUIRED)
+ENDif(WITH_LUAJIT)
+
 FIND_PACKAGE(ZLIB REQUIRED)
 FIND_LIBRARY(MATH_LIBRARY m)
 
@@ -110,6 +115,10 @@
 	${LUA_LIBRARIES}
 	${MATH_LIBRARY}
 )
+
+IF(APPLE)
+	SET(INSTEAD_LIBS ${INSTEAD_LIBS} "-framework AppKit")
+ENDIF(APPLE)
 
 IF(WITH_SDL2)
 	FIND_PACKAGE(SDL2 REQUIRED)

=== src/Makefile ===
include ../Rules.make
include ../config.make

CFLAGS += $(SDL_CFLAGS) $(LUA_CFLAGS) $(ZLIB_CFLAGS) $(EXTRA_CFLAGS)  -D_USE_SDL -DLANG_PATH=\"${LANGPATH}/\" -DSTEAD_PATH=\"${STEADPATH}/\"  -DGAMES_PATH=\"${GAMESPATH}/\" -DTHEMES_PATH=\"${THEMESPATH}/\" -DVERSION=\"$(VERSION)\" -DICON_PATH=\"${ICONPATH}/\"

LDFLAGS += $(SDL_LFLAGS) $(LUA_LFLAGS) $(ZLIB_LFLAGS) $(EXTRA_LDFLAGS)

INSTEAD_SRC	:= instead/instead.c instead/util.c instead/list.c instead/cache.c instead/idf.c instead/tinymt32.c instead/lfs.c
INSTEAD_H	:= instead/cache.h instead/system.h instead/instead.h instead/list.h instead/util.h instead/tinymt32.h instead/idf.h

SRC     := graphics.c input.c game.c main.c \
	instead_bits.c instead_sprites.c instead_timer.c instead_sound.c instead_paths.c noise1234.c \
	sound.c SDL_rotozoom.c SDL_anigif.c SDL_gfxBlitFunc.c config.c themes.c menu.c \
	utils.c unzip.c ioapi.c unpack.c $(PLATFORM) $(INSTEAD_SRC)

H	:= config.h externals.h game.h graphics.h input.h internals.h ioapi.h iowin32.h \
	menu.h SDL_rotozoom.h SDL_anigif.h SDL_gfxBlitFunc.h sound.h themes.h unzip.h $(INSTEAD_H)

OBJ     := $(patsubst %.c, %.o, $(SRC)) $(ADDOBJ)

all: sdl-instead$(EXE)

$(OBJ): %.o : %.c $(H)
	$(CC) -c $(<) $(I) $(CFLAGS) $(CPPFLAGS) -o $(@)

sdl-instead$(EXE):  $(OBJ) $(RESOURCES)
	$(CC) $(CFLAGS) $(^) $(LDFLAGS) -o $(@) 

install:
	$(INSTALLD) $(DESTDIR)$(BIN)
	$(INSTALLB) sdl-instead$(EXE) $(DESTDIR)$(BIN)/sdl-instead$(EXE)
	$(LN) sdl-instead$(EXE) $(DESTDIR)$(BIN)/instead$(EXE)

uninstall:
	$(RM) $(DESTDIR)$(BIN)/sdl-instead$(EXE)
	$(RM) $(DESTDIR)$(BIN)/instead$(EXE)

clean:
	$(RM) -f *.o instead/*.o sdl-instead$(EXE)

=== themes/CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,4 @@
-SET(THEMES arctic bluesteel book clearlooks default fantasy original wide)
+SET(THEMES arctic bluesteel book clearlooks default fantasy wide mobile)
 
 IF(SYSTEMWIDE)
 	FOREACH(THEME ${THEMES})

=== src/zlib/Makefile ===
include ../../Rules.make
include ../../config.make

OBJS = adler32.o compress.o crc32.o gzio.o uncompr.o deflate.o trees.o \
       zutil.o inflate.o infback.o inftrees.o inffast.o

all: libz.a

libz.a: $(OBJS) $(OBJA)
	$(AR) $@ $(OBJS) $(OBJA)
	-@ ($(RANLIB) $@ || true) >/dev/null 2>&1

clean:
	rm -f *.o *.a

install:

=== stead/stead3/CMakeLists.txt ===
FILE(GLOB STEAD_FILES "*.lua")
FILE(GLOB STEAD_EXT_FILES "ext/*.lua")

IF(SYSTEMWIDE)
	INSTALL(FILES ${STEAD_FILES} DESTINATION ${STEADDIR}/stead3)
	INSTALL(FILES ${STEAD_EXT_FILES} DESTINATION ${STEADDIR}/stead3/ext)
ELSEIF(STANDALONE)
	INSTALL(FILES ${STEAD_FILES} DESTINATION ${STANDALONEDIR}/stead/stead3)
	INSTALL(FILES ${STEAD_EXT_FILES} DESTINATION ${STANDALONEDIR}/stead/stead3/ext)
ENDIF(SYSTEMWIDE)

=== debian/changelog ===
instead (3.3.2-1.1build4) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- William Grant <wgrant@ubuntu.com>  Mon, 01 Apr 2024 17:04:28 +1100

instead (3.3.2-1.1build3) noble; urgency=medium

  * No-change rebuild against libglib2.0-0t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Mon, 11 Mar 2024 22:53:54 +0000

instead (3.3.2-1.1build2) noble; urgency=medium

  * No-change rebuild against libglib2.0-0t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Fri, 08 Mar 2024 05:10:23 +0000

instead (3.3.2-1.1build1) jammy; urgency=medium

  * No-change rebuild against latest gdk-pixbuf

 -- Jeremy Bicha <jeremy.bicha@canonical.com>  Wed, 09 Mar 2022 18:52:14 -0500

instead (3.3.2-1.1) unstable; urgency=medium

  * Non-maintainer upload (approved by Sam).
  * Source-only NMU to allow migration to testing.

 -- Alexander GQ Gerasiov <gq@debian.org>  Thu, 10 Sep 2020 14:25:03 +0300

instead (3.3.2-1) unstable; urgency=low

  * New upstream release.
  * Fix build error on sid/amd64 in SDL_anigif.c (Closes: #713680).
  * Bring back doc packages (English translation is ok now).
  * debian/compat:
    - Increase debhelper version up to 12.
  * debian/control:
    - Bump Standards-Version up to 4.4.1.
    - Add "Rules-Requires-Root: no" field.
  * debian/copyright:
    - Update dates.
    - Add missing authors to src/SDL_anigif.* files.
    - Fix license (change from LGPL-2.1 to correct Zlib) for files:
      src/SDL_gfxBlitFunc.*, src/SDL_rotozoom.*, src/SDL2_rotozoom.*.
  * debian/not-installed:
    - Add not-installed file to skip instead.txt installation.
  * debian/upstream/metadata:
    - Add metadata file to provide upstream info for UMEGAYA.

 -- Sam Protsenko <joe.skb7@gmail.com>  Sat, 25 Apr 2020 21:15:00 +0300

instead (3.2.2-1) unstable; urgency=low

  * New upstream release.

 -- Sam Protsenko <joe.skb7@gmail.com>  Sat, 03 Nov 2018 17:18:00 +0200

=== debian/control ===
--- 
+++ 
@@ -1,16 +1,19 @@
 Source: instead
 Section: games
 Priority: optional
-Maintainer: Sam Protsenko <joe.skb7@gmail.com>
-Build-Depends: debhelper (>= 11), dpkg-dev (>= 1.16.1~), pkg-config,
- cmake (>= 2.6.0), liblua5.1-0-dev, zlib1g-dev, libgtk2.0-dev,
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Sam Protsenko <joe.skb7@gmail.com>
+Build-Depends: debhelper (>= 12), dpkg-dev (>= 1.16.1~), pkg-config,
+ cmake (>= 2.6.0), liblua5.1-0-dev, zlib1g-dev, libgtk-3-dev,
  libsdl2-dev, libsdl2-mixer-dev, libsdl2-image-dev, libsdl2-ttf-dev
-Standards-Version: 4.1.4
+Standards-Version: 4.4.1
 Homepage: https://instead-hub.github.io/
+Rules-Requires-Root: no
 
 Package: instead
 Architecture: any
 Depends: ${shlibs:Depends}, ${misc:Depends}, instead-data (= ${source:Version})
+Suggests: instead-doc-en | instead-doc-ru
 Description: Simple text adventures/visual novels engine
  INSTEAD -- INterpreter of Simple TExt ADventure.
  Using INSTEAD you can create and play games that could be classified
@@ -41,3 +44,38 @@
  .
  This package contains language files, graphical themes, STEAD scripts
  and tutorial.
+
+Package: instead-doc-common
+Section: doc
+Architecture: all
+Depends: ${misc:Depends}
+Replaces: instead-doc-base
+Conflicts: instead-doc-base
+Description: Common documentation for INSTEAD
+ This package contains base documentation (common for all languages).
+ .
+ At the moment this contains only examples for developer's manual.
+ These examples (written in Lua) demonstrate how to implement
+ common features when you write a game for INSTEAD.
+
+Package: instead-doc-en
+Section: doc
+Architecture: all
+Depends: ${misc:Depends}, instead-doc-common (= ${source:Version})
+Description: English documentation for INSTEAD
+ This package contains game developer manual and examples in English.
+ Manual describes basic API in Lua and how to create games for INSTEAD engine.
+ .
+ Complete and latest documentation is only available in Russian, and even
+ though its English counterpart is being translated and maintained, it may lag
+ behind a little bit.
+
+Package: instead-doc-ru
+Section: doc
+Architecture: all
+Depends: ${misc:Depends}, instead-doc-common (= ${source:Version})
+Description: Russian documentation for INSTEAD
+ This package contains game developer manual and examples in Russian.
+ Manual describes basic API in Lua and how to create games for INSTEAD engine.
+ .
+ Russian documentation is complete and up to date, so it's preferred to use it.

=== debian/rules ===
--- 
+++ 
@@ -14,7 +14,7 @@
 # Put data into /usr/share/games/instead rather than /usr/share/instead
 DATADIR = share/games/instead
 # Configure CMake build
-CMAKE_FLAGS = -DWITH_SDL2=1
+CMAKE_FLAGS = -DWITH_SDL2=1 -DWITH_GTK3=1 -DWITH_GTK2=0
 # Override some variables in CMakeLists.txt
 CMAKE_CACHE_FLAGS = -DBINDIR=$(BINDIR) -DDATADIR=$(DATADIR)

=== debian/watch ===
# See uscan(1) for format

# Compulsory line, this is a version 3 file
version=3

# qa.debian.org runs a redirector which allows a simpler form of URL
# for SourceForge based projects. The format below will automatically
# be rewritten to use the redirector.
opts=pgpsigurlmangle=s/$/.asc/ http://sf.net/instead/instead_(.+)\.tar\.gz
